## manif 0.0.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)
cmake_policy(SET CMP0048 NEW)

project(manif VERSION 0.0.5 LANGUAGES CXX)

# Get the project name in capital letters
# for the lib namespace
string(TOUPPER ${PROJECT_NAME} PROJECT_NAME_CAPS)

# Check that the compoiler has c++11 support
# Crash otherwise.

if(NOT MSVC)
  include(CheckCXXCompilerFlag)
  CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
  if(COMPILER_SUPPORTS_CXX11)
    message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has C++11 support.")
  else()
    message(FATAL_ERROR "The compiler ${CMAKE_CXX_COMPILER} "
      "has no C++11 support. Please use a different C++ compiler.")
  endif()
endif()

# Finding Eigen is somewhat complicated.
# First we look for the Eigen3 cmake module
# provided by the libeigen3-dev on newer Ubuntu. If that fails, then we
# fall-back to the version provided in the cmake/modules.
find_package(Eigen3 QUIET)

if(NOT EIGEN3_FOUND)
  list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
  find_package(Eigen3 REQUIRED)
endif()

# Note that eigen 3.2 (on Ubuntu Wily) only provides EIGEN3_INCLUDE_DIR,
# not EIGEN3_INCLUDE_DIRS, so we have to set the latter from the former.
if(NOT EIGEN3_INCLUDE_DIRS)
  set(EIGEN3_INCLUDE_DIRS ${EIGEN3_INCLUDE_DIR})
endif()

# Necessary for Ubuntu 16.04's god-awful FindEigen3.cmake.
if((NOT (DEFINED EIGEN3_VERSION)) AND (DEFINED EIGEN3_VERSION_STRING))
  set(EIGEN3_VERSION ${EIGEN3_VERSION_STRING})
endif()

if(${EIGEN3_VERSION} VERSION_EQUAL "3.3.6")
  message(WARNING "Eigen3 version ${EIGEN3_VERSION} found in ${EIGEN3_INCLUDE_DIRS},"
                  "but this version has a [bug](http://eigen.tuxfamily.org/bz/show_bug.cgi?id=1643)")
elseif(${EIGEN3_VERSION} VERSION_LESS "3.3.8")
  message(WARNING "Eigen3 version ${EIGEN3_VERSION} found in ${EIGEN3_INCLUDE_DIRS}. "
                  "Beware that the move semantic has a bug and resolves to a simple copy.")
endif()

# Options. Turn on with 'cmake -DBUILD_TESTING=ON'.
# catkin build manif --cmake-args -DBUILD_TESTING=ON -DBUILD_EXAMPLES=ON
option(BUILD_TESTING "Build all tests." OFF)
option(ENABLE_CPPCHECK "Enable cppcheck." OFF)
option(BUILD_EXAMPLES "Build all examples." OFF)
option(BUILD_BENCHMARKING "Build all benchmarks." OFF)
option(BUILD_PYTHON_BINDINGS "Build Python bindings with pybind11." OFF)
option(BUILD_TESTING_PYTHON "Build Python tests only." OFF)

if (BUILD_PYTHON_BINDINGS)
  # In theory this is not required, as CMake selects the appropriate C++ standard
  # However, as long as we support pybind11 < 2.6 we need to make sure that CMAKE_CXX_STANDARD
  # is defined before   find_package(pybind11 REQUIRED)  to avoid that the CMake standard
  # command line option is set by pybind11 via the PYBIND11_CPP_STANDARD variable, in a way that could
  # interfere with CMake, see https://github.com/pybind/pybind11/blob/v2.4.3/tools/pybind11Tools.cmake#L21
  if(NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 11)
  endif()

  find_package(pybind11 REQUIRED)
  add_subdirectory(python)
endif()

###########
## Build ##
###########

add_library(${PROJECT_NAME} INTERFACE)

# @todo export c++11 dependency
# @note A per-feature basis does
# not seems to work

# CMake 3.8 ...
#set_target_properties(${PROJECT_NAME} PROPERTIES
#  INTERFACE_COMPILE_FEATURES cxx_std_11
#)

option(USE_SYSTEM_WIDE_TL_OPTIONAL "Use a system wide installation of tl-optional" OFF)

find_package(tl-optional 1.0.0 QUIET)
if(USE_SYSTEM_WIDE_TL_OPTIONAL AND NOT tl-optional_FOUND)
  message(FATAL_ERROR "Could not find required package tl-optional")
endif()

target_include_directories(${PROJECT_NAME} INTERFACE
  "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include$<$<NOT:$<BOOL:${tl-optional_FOUND}>>:;${PROJECT_SOURCE_DIR}/external/tl>>"
  "$<INSTALL_INTERFACE:include>"
)
target_link_libraries(${PROJECT_NAME} INTERFACE "$<$<BOOL:${tl-optional_FOUND}>:tl::optional>")

# Add Eigen interface dependency, depending on available cmake info
if(TARGET Eigen3::Eigen)
  target_link_libraries(${PROJECT_NAME} INTERFACE Eigen3::Eigen)
  set(Eigen3_DEPENDENCY "find_dependency(Eigen3 ${Eigen3_VERSION})")
else(TARGET Eigen3::Eigen)
  target_include_directories(${PROJECT_NAME} SYSTEM INTERFACE ${EIGEN3_INCLUDE_DIRS})
endif(TARGET Eigen3::Eigen)

# Add tl-optional interface dependency if enabled
if(tl-optional_FOUND)
  set(tl-optional_DEPENDENCY "find_dependency(tl-optional)")
else()
  set(tl-optional_DEPENDENCY "")
endif()

if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  target_compile_options(${PROJECT_NAME} INTERFACE -ftemplate-depth=512)
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
  target_compile_options(${PROJECT_NAME} INTERFACE /bigobj)
endif()

#############
## Install ##
#############

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

set(config_install_dir "share/${PROJECT_NAME}/cmake")
set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated")

# Targets:
install(
  TARGETS  ${PROJECT_NAME}
  EXPORT   ${PROJECT_NAME}Targets
  INCLUDES DESTINATION include
)

install(
  EXPORT      ${PROJECT_NAME}Targets
  NAMESPACE   ${PROJECT_NAME_CAPS}::
  DESTINATION "${config_install_dir}"
)

export(
  TARGETS ${PROJECT_NAME}
  NAMESPACE ${PROJECT_NAME_CAPS}::
  FILE ${PROJECT_NAME}Targets.cmake
)

export(PACKAGE ${PROJECT_NAME})

## Configuration

#
configure_package_config_file(
  "${PROJECT_SOURCE_DIR}/cmake/${PROJECT_NAME}Config.cmake.in"
  "${generated_dir}/${PROJECT_NAME}Config.cmake"
  INSTALL_DESTINATION "${config_install_dir}"
)

# Configure '<PROJECT-NAME>ConfigVersion.cmake'
write_basic_package_version_file(
  "${generated_dir}/${PROJECT_NAME}ConfigVersion.cmake"
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY AnyNewerVersion
  ARCH_INDEPENDENT
)

# Config
install(
  FILES
    "${generated_dir}/${PROJECT_NAME}ConfigVersion.cmake"
    "${generated_dir}/${PROJECT_NAME}Config.cmake"
  DESTINATION "${config_install_dir}"
)

# Headers:

# if tl-optional is not found manif will install its own version
if(NOT tl-optional_FOUND)
  install(
    FILES "${PROJECT_SOURCE_DIR}/external/tl/tl/optional.hpp"
    DESTINATION include/tl
  )
endif()

install(
  DIRECTORY "${PROJECT_SOURCE_DIR}/include/${PROJECT_NAME}"
  DESTINATION include
)

# Test utils
install(
  FILES
    "${PROJECT_SOURCE_DIR}/test/gtest_eigen_utils.h"
    "${PROJECT_SOURCE_DIR}/test/gtest_manif_utils.h"
  DESTINATION "include/${PROJECT_NAME}/gtest"
)

##############
## Examples ##
##############

if(BUILD_EXAMPLES)

  add_subdirectory(examples)

endif(BUILD_EXAMPLES)

#############
## Testing ##
#############

# ------------------------------------------------------------------------------
# Coverage
# ------------------------------------------------------------------------------

if(ENABLE_COVERAGE)
  add_definitions(-DMANIF_COVERAGE_ENABLED)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g ")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
endif()

# ------------------------------------------------------------------------------
# CppCheck
# ------------------------------------------------------------------------------

if(ENABLE_CPPCHECK)

  # Find CppCheck executable
  find_program(CPPCHECK "cppcheck")
  if(CPPCHECK)

      # Set export commands on
      # set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

      list(APPEND CPPCHECK_ARGS
        --enable=all
        --std=c++11
        # --verbose
        --quiet
        # --check-config
        --xml-version=2
        --language=c++
        # Comment the line below to run cppcheck-html
        --error-exitcode=1
        --inline-suppr
        --suppress=*:*googletest-*
        --suppress=missingIncludeSystem
        --suppress=missingInclude
        --suppress=unmatchedSuppression:*
        --suppress=syntaxError:*tangent_base.h:370
        --suppress=unknownMacro:*test/common_tester.h
        --suppress=unknownMacro:*test/ceres/ceres_test_utils.h
        --suppress=constStatement:*examples*
        --suppress=constStatement:*gtest_misc.cpp:35
        --suppress=constStatement:*gtest_misc.cpp:43
        --suppress=unreadVariable:*gtest_se2_ceres_autodiff.cpp:101
        --suppress=unreadVariable:*bundle_sam.cpp:94
        --suppress=unreadVariable:*bundle_sam.cpp:124
        # Uncomment the line below to run cppcheck-html
        # --output-file=${CMAKE_BINARY_DIR}/cppcheck_results.xml
        ${CMAKE_SOURCE_DIR}/include
        ${CMAKE_SOURCE_DIR}/examples
        ${CMAKE_SOURCE_DIR}/test
      )

      add_custom_target(run-cppcheck
          COMMAND ${CPPCHECK} ${CPPCHECK_ARGS}
          COMMENT "Generate cppcheck report for the project"
      )

      find_program(CPPCHECK_HTML "cppcheck-htmlreport")
      if(CPPCHECK_HTML)
          add_custom_target(cppcheck-html
              COMMAND ${CPPCHECK_HTML}
              --title=${CMAKE_PROJECT_NAME}
              --file=${CMAKE_BINARY_DIR}/cppcheck_results.xml
              --report-dir=${CMAKE_BINARY_DIR}/cppcheck_results
              --source-dir=${CMAKE_SOURCE_DIR}
              COMMENT "Convert cppcheck report to HTML output"
          )
          ADD_DEPENDENCIES(cppcheck-html run-cppcheck)
      endif()
  endif()

endif()

# ------------------------------------------------------------------------------
# Valgrind
# ------------------------------------------------------------------------------

if(ENABLE_VALGRIND)
  # ctest -T memcheck
  include(CTest)
  set(MEMORYCHECK_COMMAND_OPTIONS "${MEMORYCHECK_COMMAND_OPTIONS} --leak-check=full")
  set(MEMORYCHECK_COMMAND_OPTIONS "${MEMORYCHECK_COMMAND_OPTIONS} --track-fds=yes")
  set(MEMORYCHECK_COMMAND_OPTIONS "${MEMORYCHECK_COMMAND_OPTIONS} --trace-children=yes")
  set(MEMORYCHECK_COMMAND_OPTIONS "${MEMORYCHECK_COMMAND_OPTIONS} --show-reachable=yes")
  set(MEMORYCHECK_COMMAND_OPTIONS "${MEMORYCHECK_COMMAND_OPTIONS} --error-exitcode=1")
endif()

# ------------------------------------------------------------------------------
# Unit Tests
# ------------------------------------------------------------------------------

if(BUILD_TESTING)

  enable_testing()
  add_subdirectory(test)

endif(BUILD_TESTING)

if(BUILD_PYTHON_BINDINGS AND (BUILD_TESTING OR BUILD_TESTING_PYTHON))

  enable_testing()
  add_subdirectory(test/python)

endif()

# ------------------------------------------------------------------------------
# Benchmark
# ------------------------------------------------------------------------------

if(BUILD_BENCHMARKING)

  add_subdirectory(benchmark)

endif(BUILD_BENCHMARKING)

=== benchmark/CMakeLists.txt ===
find_package(benchmark QUIET)

if(NOT benchmark_FOUND)
  # If not found, download it
  include(FetchContent)
  FetchContent_Declare(
    googlebenchmark
    GIT_REPOSITORY https://github.com/google/benchmark.git
    GIT_TAG        v1.5.2
  )
  set(BENCHMARK_ENABLE_TESTING OFF)
  FetchContent_MakeAvailable(googlebenchmark)
endif()

# small helper function
function(manif_add_benchmark target)
  add_executable(${target} ${ARGN})
  # add_dependencies(${target} gtest)
  target_link_libraries(${target} ${PROJECT_NAME} benchmark::benchmark)

  if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    # GCC is not strict enough by default, so enable most of the warnings.
    target_compile_options(${target} PRIVATE
      -Werror=all
      -Werror=extra
      # When the library is built using GCC it is necessary to link
      # with the pthread library due to how GCC implements std::thread.
      # See https://github.com/google/benchmark#platform-specific-build-instructions
      -pthread
    )
  endif()
endfunction()

manif_add_benchmark(benchmark_so2 benchmark_so2.cpp)
manif_add_benchmark(benchmark_se2 benchmark_se2.cpp)
manif_add_benchmark(benchmark_so3 benchmark_so3.cpp)
manif_add_benchmark(benchmark_se3 benchmark_se3.cpp)
manif_add_benchmark(benchmark_se_2_3 benchmark_se_2_3.cpp)
manif_add_benchmark(benchmark_rn benchmark_rn.cpp)

manif_add_benchmark(benchmark_manif benchmark_manif.cpp)

manif_add_benchmark(benchmark_quat benchmark_quat.cpp)

set(CXX_17_TEST_TARGETS
  benchmark_so2
  benchmark_se2
  benchmark_so3
  benchmark_se3
  benchmark_se_2_3
  benchmark_rn

  benchmark_manif

  benchmark_quat
)

# Set required C++17 flag
set_property(TARGET ${CXX_17_TEST_TARGETS} PROPERTY CXX_STANDARD 17)
set_property(TARGET ${CXX_17_TEST_TARGETS} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${CXX_17_TEST_TARGETS} PROPERTY CXX_EXTENSIONS OFF)

=== examples/CMakeLists.txt ===
add_executable(so2_average so2_average.cpp)

add_executable(se2_average se2_average.cpp)
add_executable(se2_interpolation se2_interpolation.cpp)
add_executable(se2_decasteljau se2_DeCasteljau.cpp)
add_executable(se2_localization se2_localization.cpp)
add_executable(se2_localization_ukfm se2_localization_ukfm.cpp)
add_executable(se2_sam se2_sam.cpp)

add_executable(se3_localization se3_localization.cpp)
add_executable(se3_sam se3_sam.cpp)
add_executable(se3_sam_selfcalib se3_sam_selfcalib.cpp)

add_executable(se_2_3_localization se_2_3_localization.cpp)

set(CXX_11_EXAMPLE_TARGETS

  # SO2
  so2_average

  # SE2
  se2_interpolation
  se2_decasteljau
  se2_average
  se2_localization
  se2_sam

  se2_localization_ukfm

  # SE3
  se3_localization
  se3_sam
  se3_sam_selfcalib

  # SE_2_3
  se_2_3_localization
)

if(NOT MSVC)
  add_executable(bundle_sam bundle_sam.cpp)

  set(CXX_11_EXAMPLE_TARGETS

    ${CXX_11_EXAMPLE_TARGETS}

    # Bundle
    bundle_sam
  )
endif()

# Link to manif
foreach(target ${CXX_11_EXAMPLE_TARGETS})
  target_link_libraries(${target} ${PROJECT_NAME})

  if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    # GCC is not strict enough by default, so enable most of the warnings.
    target_compile_options(${target} PRIVATE
      -Werror=all
      -Werror=extra
    )
  endif()

endforeach()

# Set required C++11 flag
set_property(TARGET ${CXX_11_EXAMPLE_TARGETS} PROPERTY CXX_STANDARD 11)
set_property(TARGET ${CXX_11_EXAMPLE_TARGETS} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${CXX_11_EXAMPLE_TARGETS} PROPERTY CXX_EXTENSIONS OFF)

=== python/CMakeLists.txt ===
pybind11_add_module(manifpy MODULE
  bindings_rn.cpp
  bindings_so2.cpp
  bindings_so3.cpp
  bindings_se2.cpp
  bindings_se3.cpp
  bindings_se_2_3.cpp
  bindings_sgal3.cpp
  bindings_manif.cpp
)
target_link_libraries(manifpy PRIVATE ${PROJECT_NAME})
# Eigen and numpy have different default storage order.
# See e.g. https://pybind11.readthedocs.io/en/stable/advanced/cast/eigen.html#storage-orders
target_compile_definitions(manifpy PRIVATE EIGEN_DEFAULT_TO_ROW_MAJOR)

# Specify that C++11 features are required
target_compile_features(manifpy PRIVATE cxx_nullptr)
set_property(TARGET manifpy PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET manifpy PROPERTY CXX_EXTENSIONS OFF)

if (CALL_FROM_SETUP_PY)
  # cmake-build-extension sets the full absolute path as CMAKE_INSTALL_PREFIX.
  set(MANIFPY_PKGDIR "${CMAKE_INSTALL_PREFIX}")
  set(MANIFPY_INSTDIR "${CMAKE_INSTALL_PREFIX}")
# Permit to specify MANIFPY_INSTDIR as an option
elseif(NOT DEFINED MANIFPY_PKGDIR)
  # 'distutils.sysconfig.get_python_lib' returns the absolute path of Python
  # by default a global location managed by the distro e.g. /usr/lib/python.
  #
  # pybind11 and FindPython3 set respectively PYTHON_SITE_PACKAGES/Python3_SITELIB
  # from 'distutils.sysconfig.get_python_lib'
  #
  # Those are especially annoying on Ubuntu since it has
  # some hardcoded paths in python3.x/site.py
  #
  # `sysconfig.get_path` may return paths that does not even exists.
  #
  # So below we retrieve the first site-package path from 'site.getsitepackages()'.

  execute_process(
    COMMAND
    ${PYTHON_EXECUTABLE} -c "import site; print(site.getsitepackages()[0])"
    OUTPUT_VARIABLE _PYTHON_SITE_PACKAGE OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  set(MANIFPY_PKGDIR "${_PYTHON_SITE_PACKAGE}")
  set(MANIFPY_INSTDIR "${MANIFPY_PKGDIR}/manifpy")
else()
  set(MANIFPY_INSTDIR "${MANIFPY_PKGDIR}/manifpy")
endif()

message(STATUS "Installing manifpy in ${MANIFPY_INSTDIR}")

# Setup installation path
install(TARGETS manifpy COMPONENT python DESTINATION "${MANIFPY_INSTDIR}")

# Create the Python package in the build tree for testing purposes
set(MANIFPY_BUILDDIR "${CMAKE_BINARY_DIR}/manifpy")
set_target_properties(
  manifpy PROPERTIES
  OUTPUT_NAME _bindings
  LIBRARY_OUTPUT_DIRECTORY "${MANIFPY_BUILDDIR}")

# Create the __init__.py file
file(
  GENERATE
  OUTPUT "${MANIFPY_BUILDDIR}/__init__.py"
  CONTENT "from manifpy._bindings import *\n")

# Install the __init__.py file
install(
  FILES "${MANIFPY_BUILDDIR}/__init__.py"
  DESTINATION ${MANIFPY_INSTDIR})
  
# Install pip metadata files to ensure that manif installed via CMake is listed by pip list
# See https://packaging.python.org/specifications/recording-installed-packages/
# and https://packaging.python.org/en/latest/specifications/core-metadata/#core-metadata
if (NOT CALL_FROM_SETUP_PY)
  file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/METADATA "")
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/METADATA "Metadata-Version: 2.1\n")
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/METADATA "Name: manifpy\n")
  file(APPEND ${CMAKE_CURRENT_BINARY_DIR}/METADATA "Version: ${PROJECT_VERSION}\n")
  file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/INSTALLER "cmake\n")
  install(
    FILES "${CMAKE_CURRENT_BINARY_DIR}/METADATA" "${CMAKE_CURRENT_BINARY_DIR}/INSTALLER"
    DESTINATION ${MANIFPY_PKGDIR}/manifpy-${PROJECT_VERSION}.dist-info)
endif()

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)

find_package(GTest QUIET)

if(NOT GTEST_FOUND)
  # If not found, download it

  # Download and unpack googletest at configure time
  configure_file(gtest/CMakeLists.txt.in gtest/CMakeLists.txt)
  execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
    RESULT_VARIABLE result
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/gtest )
  if(result)
    message(FATAL_ERROR "CMake step for googletest failed: ${result}")
  endif()
  execute_process(COMMAND ${CMAKE_COMMAND} --build .
    RESULT_VARIABLE result
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/gtest )
  if(result)
    message(FATAL_ERROR "Build step for googletest failed: ${result}")
  endif()

  # Prevent overriding the parent project's compiler/linker
  # settings on Windows
  set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

  # Add googletest directly to our build. This defines
  # the gtest and gtest_main targets.
  add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/googletest-src
                   ${CMAKE_CURRENT_BINARY_DIR}/googletest-build
                   EXCLUDE_FROM_ALL)
endif()

# small helper function
function(manif_add_gtest target)
  add_executable(${target} ${ARGN})
  add_dependencies(${target} gtest)
  target_link_libraries(${target} ${PROJECT_NAME} gtest)

  if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    # GCC is not strict enough by default, so enable most of the warnings.
    target_compile_options(${target} PRIVATE
      -Werror=all
      -Werror=extra
      )
  endif()

  add_test(NAME ${target} COMMAND ${target})
endfunction()

include_directories(${GTEST_INCLUDE_DIRS})

manif_add_gtest(gtest_misc gtest_misc.cpp)

set(CXX_TEST_TARGETS

  ${CXX_TEST_TARGETS}

  gtest_misc
)

# # R^n tests
add_subdirectory(rn)

# # SO2 tests
add_subdirectory(so2)

# # SO3 tests
add_subdirectory(so3)

# # SE2 tests
add_subdirectory(se2)

# # SE3 tests
add_subdirectory(se3)

# # SE_2_3 tests
add_subdirectory(se_2_3)

# # SGal3 tests
add_subdirectory(sgal3)

if(NOT MSVC)
  # Bundle tests
  add_subdirectory(bundle)
endif()

find_package(Ceres QUIET)

if(CERES_FOUND)

  message(STATUS "Found ceres_solver, building ceres tests.")
  add_subdirectory(ceres)

else()
  message(STATUS "Could not find ceres_solver, ceres tests will not be built.")
endif()

find_package(autodiff QUIET)

if(autodiff_FOUND)

  message(STATUS "Found autodiff, building autodiff tests.")
  add_subdirectory(autodiff)

else()
  message(STATUS "Could not find autodiff, autodiff tests will not be built.")
endif()

if(NOT DEFINED CMAKE_CXX_STANDARD)
  # Set required C++11 flag
  set_property(TARGET ${CXX_TEST_TARGETS} PROPERTY CXX_STANDARD 11)
endif()
set_property(TARGET ${CXX_TEST_TARGETS} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${CXX_TEST_TARGETS} PROPERTY CXX_EXTENSIONS OFF)

=== test/autodiff/CMakeLists.txt ===
# autodiff tests

if(NOT MSVC)
  include(CheckCXXCompilerFlag)
  CHECK_CXX_COMPILER_FLAG("-std=c++17" COMPILER_SUPPORTS_CXX17)
  if(COMPILER_SUPPORTS_CXX17)
    message(STATUS "The compiler ${CMAKE_CXX_COMPILER} has C++17 support.")
  else()
    message(FATAL_ERROR
      "The compiler ${CMAKE_CXX_COMPILER} has no C++17 support."
      "The library 'autodiff' requires a C++17 compliant compiler."
    )
  endif()
endif()

manif_add_gtest(gtest_autodiff gtest_autodiff.cpp)

set(CXX_17_TEST_TARGETS_AUTODIFF
  gtest_autodiff
)

foreach(target ${CXX_17_TEST_TARGETS_AUTODIFF})
  target_link_libraries(${target} autodiff::autodiff)
endforeach()

# Set required C++17 flag
set_property(TARGET ${CXX_17_TEST_TARGETS_AUTODIFF} PROPERTY CXX_STANDARD 17)
set_property(TARGET ${CXX_17_TEST_TARGETS_AUTODIFF} PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET ${CXX_17_TEST_TARGETS_AUTODIFF} PROPERTY CXX_EXTENSIONS OFF)

=== test/bundle/CMakeLists.txt ===
# Bundle tests

manif_add_gtest(gtest_bundle gtest_bundle.cpp)
manif_add_gtest(gtest_bundle_single_group gtest_bundle_single_group.cpp)
manif_add_gtest(gtest_bundle_large gtest_bundle_large.cpp)

set(CXX_TEST_TARGETS

  ${CXX_TEST_TARGETS}

  gtest_bundle
  gtest_bundle_single_group
  gtest_bundle_large

  PARENT_SCOPE
)

=== test/ceres/CMakeLists.txt ===
# Ceres tests

manif_add_gtest(gtest_rn_ceres gtest_rn_ceres.cpp)

manif_add_gtest(gtest_so2_ceres gtest_so2_ceres.cpp)

manif_add_gtest(gtest_se2_ceres_autodiff gtest_se2_ceres_autodiff.cpp)
manif_add_gtest(gtest_se2_ceres gtest_se2_ceres.cpp)

manif_add_gtest(gtest_so3_ceres gtest_so3_ceres.cpp)

manif_add_gtest(gtest_se3_ceres gtest_se3_ceres.cpp)

manif_add_gtest(gtest_se23_ceres gtest_se23_ceres.cpp)

manif_add_gtest(gtest_sgal3_ceres gtest_sgal3_ceres.cpp)

manif_add_gtest(gtest_bundle_ceres gtest_bundle_ceres.cpp)

set(CXX_TEST_TARGETS_CERES
  # Rn
  gtest_rn_ceres

  # SO2
  gtest_so2_ceres

  # SO3
  gtest_so3_ceres

  # SE2
  gtest_se2_ceres_autodiff
  gtest_se2_ceres

  # SE3
  gtest_se3_ceres

  # SE23
  gtest_se23_ceres

  # SGal3
  gtest_sgal3_ceres

  # Bundle
  gtest_bundle_ceres
)

foreach(target ${CXX_TEST_TARGETS_CERES})
  target_link_libraries(${target} ${CERES_LIBRARIES})
  target_include_directories(${target} SYSTEM PRIVATE ${CERES_INCLUDE_DIRS})
endforeach()

set(CXX_TEST_TARGETS
  ${CXX_TEST_TARGETS}
  ${CXX_TEST_TARGETS_CERES}

  PARENT_SCOPE
)

=== test/python/CMakeLists.txt ===
# small helper function
function(manif_add_pytest target)
  add_test(
    NAME ${target}
    COMMAND pytest-3 ${target}.py
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
  set_tests_properties(${target}
    PROPERTIES ENVIRONMENT "PYTHONPATH=${CMAKE_BINARY_DIR}:$ENV{PYTHONPATH}"
  )
endfunction()

manif_add_pytest(test_manif)
manif_add_pytest(test_so2)
manif_add_pytest(test_se2)
manif_add_pytest(test_so3)
manif_add_pytest(test_se3)
manif_add_pytest(test_se_2_3)

=== test/rn/CMakeLists.txt ===
# SO3 tests

manif_add_gtest(gtest_rn gtest_rn.cpp)

set(CXX_TEST_TARGETS

  ${CXX_TEST_TARGETS}

  # R^n
  gtest_rn

  PARENT_SCOPE
)

=== test/se2/CMakeLists.txt ===
# SE2 tests

manif_add_gtest(gtest_se2 gtest_se2.cpp)
manif_add_gtest(gtest_se2_map gtest_se2_map.cpp)
manif_add_gtest(gtest_se2_tangent gtest_se2_tangent.cpp)
manif_add_gtest(gtest_se2_tangent_map gtest_se2_tangent_map.cpp)

set(CXX_TEST_TARGETS

  ${CXX_TEST_TARGETS}

  # SE2
  gtest_se2
  gtest_se2_map
  gtest_se2_tangent
  gtest_se2_tangent_map

  PARENT_SCOPE
)

=== test/se3/CMakeLists.txt ===
# SE3 tests

manif_add_gtest(gtest_se3 gtest_se3.cpp)

set(CXX_TEST_TARGETS

  ${CXX_TEST_TARGETS}

  # SE3
  gtest_se3

  PARENT_SCOPE
)

=== debian/changelog ===
manif (0.0.5-6ubuntu4) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 14:12:54 +0000

manif (0.0.5-6ubuntu3) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 17:34:38 +0000

manif (0.0.5-6ubuntu2) plucky; urgency=medium

  * No-change rebuild against python3-numpy2-abi0

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 28 Jan 2025 11:29:18 +0000

manif (0.0.5-6ubuntu1) plucky; urgency=medium

  * Build with -O2 on amd64 to avoid gtest_bundle_large failure

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 19 Nov 2024 13:39:01 +0000

manif (0.0.5-6build1) plucky; urgency=medium

  * No-change rebuild to add support for Python 3.13.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Nov 2024 19:30:43 +0100

manif (0.0.5-6) unstable; urgency=medium

  * Ignore test failures on 32-bit architectures

 -- Timo Röhling <roehling@debian.org>  Thu, 03 Oct 2024 22:40:08 +0200

manif (0.0.5-5) unstable; urgency=medium

  * Completely disable test suite on 32 bit architectures

 -- Timo Röhling <roehling@debian.org>  Sun, 08 Sep 2024 21:22:52 +0200

manif (0.0.5-4) unstable; urgency=medium

  * Disable Rn test on 32-bit architectures (again)

 -- Timo Röhling <roehling@debian.org>  Sun, 08 Sep 2024 16:17:26 +0200

manif (0.0.5-3) unstable; urgency=medium

  * Reduce excessive memory consumption during build.
    Thanks to Santiago Vila (Closes: #1081058)

 -- Timo Röhling <roehling@debian.org>  Sun, 08 Sep 2024 09:06:16 +0200

manif (0.0.5-2) unstable; urgency=medium

  * Skip C++ test suite on 32 bit architectures

 -- Timo Röhling <roehling@debian.org>  Fri, 16 Aug 2024 17:05:53 +0200

manif (0.0.5-1) unstable; urgency=medium

  * Initial release (Closes: #1072738)

 -- Timo Röhling <roehling@debian.org>  Tue, 13 Aug 2024 00:24:44 +0200

=== debian/control ===
Source: manif
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
Uploaders: Timo Röhling <roehling@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 dh-sequence-python3,
 dh-sequence-numpy3,
 libceres-dev <!nocheck>,
 libeigen3-dev,
 libgtest-dev <!nocheck>,
 libpython3-all-dev,
 libtl-optional-dev,
 ninja-build,
 pybuild-plugin-pyproject,
 python3-all-dev:any,
 python3-cmake-build-extension:native,
 python3-numpy,
 python3-pybind11,
 python3-pytest <!nocheck>,
 python3-setuptools,
Homepage: https://github.com/artivis/manif
Standards-Version: 4.7.0
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-pybuild
Vcs-Git: https://salsa.debian.org/robotics-team/manif.git
Vcs-Browser: https://salsa.debian.org/robotics-team/manif
Description: Lie theory library for state estimation
 manif is a Lie theory library for state estimation targeted at robotics
 applications. It is developed as a header-only C++11 library with Python 3
 wrappers.

Package: libmanif-dev
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 libeigen3-dev,
 libtl-optional-dev,
Recommends:
 libceres-dev,
Description: ${source:Synopsis} (C++)
 ${source:Extended-Description}
 .
 This package installs the C++ library.

Package: python3-manifpy
Section: python
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 ${python3:Depends},
Description: ${source:Synopsis} (Python 3)
 ${source:Extended-Description}
 .
 This package installs the Python 3 module.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

BUILD_TESTING = $(if $(or $(filter 32,$(DEB_HOST_ARCH_BITS)),$(filter nocheck,$(DEB_BUILD_OPTIONS))),OFF,ON)

ifeq ($(DEB_HOST_ARCH_BITS),32)
export PYBUILD_TEST_ARGS = || true
endif

ifneq (,$(filter $(DEB_HOST_ARCH), amd64))
  export DEB_CXXFLAGS_MAINT_APPEND=-O2
endif

export CMAKE_BUILD_EXTENSION_DEBIAN = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export SETUPTOOLS_SCM_PRETEND_VERSION = $(DEB_VERSION_UPSTREAM)
export PYBUILD_AFTER_INSTALL = rm -r {destdir}{install_dir}/manifpy/include {destdir}{install_dir}/manifpy/share

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --buildsystem=pybuild
	dh_auto_configure --buildsystem=cmake -- \
		-DBUILD_PYTHON_BINDINGS=OFF \
		-DBUILD_TESTING=$(BUILD_TESTING)

override_dh_auto_clean \
override_dh_auto_build \
override_dh_auto_install \
override_dh_auto_test: override_%:
	$* --buildsystem=pybuild
	$* --buildsystem=cmake -O--no-parallel

=== debian/tests/control ===
Tests: run-cpp-testsuite
Depends:
 @,
 cmake,
 g++ | c++-compiler,
 libceres-dev,
 libgtest-dev,
Restrictions:
 allow-stderr,
 skippable

=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s%(?:.*?/)?v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,uversionmangle=s%[.-]?(a|b|c|rc|dev|pre)%~$1% \
 https://api.github.com/repos/artivis/manif/tags \
 tarball/(?:[^"]*?/)?[a-z]*@ANY_VERSION@
